package com.tzld.piaoquan.ad.engine.commons.util;

public class NumUtil {

    public static double div(double d1, double d2) {
        if (d1 == 0 || d2 == 0) {
            return 0d;
        }
        return d1 / d2;
    }


    public static double log(double a) {
        if (a <= 0) {
            return 0D;
        }
        return Math.log(a + 1.0);
    }

    public static double log10(double a) {
        if (a <= 0) {
            return 0d;
        }
        return Math.log10(a + 1.0);
    }

    public static double sigmoid(double x) {
        return 1 / (1 + Math.exp(-x));
    }

    @SafeVarargs
    public static <T extends Comparable<T>> T min(T... values) {
        if (values == null || values.length == 0) {
            throw new IllegalArgumentException("Values cannot be null or empty");
        }

        T minValue = values[0];
        for (T value : values) {
            if (value.compareTo(minValue) < 0) {
                minValue = value;
            }
        }

        return minValue;
    }

}
